// MailslotServer.cpp : Defines the entry point for the console application.

#include "stdafx.h"

int main(void)
{
     HANDLE hMailslot=CreateMailslot("\\\\.\\mailslot\\TestSlot1",4096,MAILSLOT_WAIT_FOREVER,NULL);
     if(hMailslot == INVALID_HANDLE_VALUE) 
     {
          printf("Cannot create mailslot\n");
          exit(1);
	 }
     printf("Mailslot created.\n");
     
     while(1)
     {
         printf("Waiting for client ...\n");

		 char buffer[4096];
         DWORD BytesRead;
     
         BOOL ok=ReadFile(hMailslot,buffer,4096,&BytesRead,NULL);          
         if (!ok||!BytesRead) 
         {
             printf("Cannot read from mailslot.");
			 CloseHandle(hMailslot);
			 exit(1);
		 }
         printf("Read from client: '%s'\n",buffer);
     }

     CloseHandle(hMailslot);

     return 0;
}