// SHMwrite.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

int main(void)
{
	char *buffer;

	HANDLE hSharedMemory = CreateFileMapping(INVALID_HANDLE_VALUE,NULL,PAGE_READWRITE,0,4096,"TestSharedMemory1");
    if (!hSharedMemory) 
    {
		printf("Cannot create shared memory.\n");
        exit(1);
    }
	if(GetLastError()==ERROR_ALREADY_EXISTS)
		printf("Existing shared memory objected opened.\n");
	else
		printf("New shared memory objected created.\n");

	buffer=(char*)MapViewOfFile(hSharedMemory,FILE_MAP_ALL_ACCESS,0,0,4096);
    if(!buffer) 
    {
		printf("Cannot map shared memory.\n");
		CloseHandle(hSharedMemory);
        exit(1);
    }
	printf("Shared memory mapped.\n");
	strcpy(buffer,"Ahoj");
	printf("'Ahoj' written to shared memory.\n");
	printf("Sleeping 20 seconds ...\n");
	Sleep(20000);
	BOOL ok=UnmapViewOfFile(buffer);
	if (!ok) 
    {
		printf("Cannot unmap memory.\n");
		CloseHandle(hSharedMemory);
        exit(1);
    }
	printf("Memory unmapped.\n");
	CloseHandle(hSharedMemory);
	printf("Handle closed.\n");
}
     