// PipeClient.cpp : Defines the entry point for the console application.

#include "stdafx.h"

int main(void)
{
    HANDLE hPipe=CreateFile("\\\\.\\Pipe\\TestPipe1",GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
    if(hPipe == INVALID_HANDLE_VALUE) 
    {
        printf("Cannot connect to server pipe.");
        exit(1);
    }
    printf("Connected to server.\n");
     
	char buffer[4096];
    DWORD BytesWritten,BytesRead;

    BOOL ok=WriteFile(hPipe,"Ahoj",5,&BytesWritten,NULL);
    if(!ok||BytesWritten!=5)
    {
        printf("Cannot write to pipe.\n");
        CloseHandle(hPipe);
        exit(1);
    }
    printf("Writing to pipe was successfull (\"Ahoj\").\n");
     
	ok=ReadFile(hPipe,buffer,4096,&BytesRead,NULL);
    if (!ok||!BytesRead) 
    {
        printf("Cannot read from pipe.\n");
        CloseHandle(hPipe);
        exit(1);
    }
    printf("Read from pipe: '%s'\n", buffer); 
    CloseHandle(hPipe);
    printf("Pipe handle closed.\n");

	return 0;
}

